dofile_once("data/scripts/gun/gun_enums.lua")
dofile_once("data/scripts/gun/gun_actions.lua")

local entity_id = GetUpdatedEntityID()
local target_x, target_y = EntityGetTransform(entity_id)
SetRandomSeed(target_x, target_y)
--print(Random(1,100))
if Random(1,100) > ModSettingGet("mimic_info_box.rate") then
    EntityRemoveComponent(entity_id,GetUpdatedComponentID())
    return
end

function get_acion_info(action_id)
    for _, data in pairs(actions) do
        if data.id == action_id then
            return data.type, data.sprite
        end
    end
end



--disable wand
local item_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "ItemComponent")
ComponentSetValue2(item_comp, "is_pickable", false)
local interact_text = GameTextGet("$itempickup_pick", "[E]", GameTextGet("$item_wand"))
EntityAddComponent2(
    entity_id,
    "InteractableComponent",
    {
        radius = 10,
        ui_text = interact_text,
        name = "invoke_panel_mimic"
    }
)
EntityAddComponent2(
    entity_id,
    "LuaComponent",
    {
        script_interacting = "mods/mimic_info_box/scripts/interact_mimic.lua"
    }
)
EntityRemoveTag(entity_id, "wand")
--load mimic
--TODO:add custom font image
--[[
local font_file = "data/fonts/font_pixel_white.xml"
local langue = GameTextGet("$current_language")
if langue=="简体中文"then
    
end
]]
target_y = target_y - 200 / 3
target_x = target_x + 115 / 3

local capacity
local wand_attri = {
    {"data/ui_gfx/inventory/icon_gun_shuffle.png", "$inventory_shuffle", "No"},
    {"data/ui_gfx/inventory/icon_gun_actions_per_round.png", "$inventory_actionspercast", "1"},
    {"data/ui_gfx/inventory/icon_fire_rate_wait.png", "$inventory_castdelay", "$inventory_seconds"},
    {"data/ui_gfx/inventory/icon_gun_reload_time.png", "$inventory_rechargetime", "$inventory_seconds"},
    {"data/ui_gfx/inventory/icon_mana_max.png", "$inventory_manamax", "200"},
    {"data/ui_gfx/inventory/icon_mana_charge_speed.png", "$inventory_manachargespeed", "200"},
    {"data/ui_gfx/inventory/icon_gun_capacity.png", "$inventory_capacity", "3"},
    {"data/ui_gfx/inventory/icon_spread_degrees.png", "$inventory_spread", "$inventory_degrees", "0.0"}
}

local ability_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "AbilityComponent")
if ability_comp == nil then
    EntityRemoveComponent(entity_id, GetUpdatedComponentID())
    return
end

if ComponentObjectGetValue2(ability_comp, "gun_config", "shuffle_deck_when_empty") then
    wand_attri[1][3] = "Yes"
else
    wand_attri[1][3] = "No"
end
wand_attri[2][3] = tostring(ComponentObjectGetValue2(ability_comp, "gun_config", "actions_per_round"))
wand_attri[3][3] =
    GameTextGet(
    wand_attri[3][3],
    string.format("%.2f", ComponentObjectGetValue2(ability_comp, "gunaction_config", "fire_rate_wait")/60)
)
wand_attri[4][3] =
    GameTextGet(
    wand_attri[4][3],
    string.format("%.2f", ComponentObjectGetValue2(ability_comp, "gun_config", "reload_time")/60)
)
wand_attri[5][3] = tostring(math.floor(ComponentGetValue2(ability_comp, "mana_max") + 0.5))
wand_attri[6][3] = tostring(math.floor(ComponentGetValue2(ability_comp, "mana_charge_speed") + 0.5))
capacity = ComponentObjectGetValue2(ability_comp, "gun_config", "deck_capacity")
wand_attri[7][3] = tostring(capacity)
wand_attri[8][3] =
    GameTextGet(
    wand_attri[8][3],
    tostring(math.floor(ComponentObjectGetValue2(ability_comp, "gunaction_config", "spread_degrees"))) .. ".0"
)

local wand_icon_image = ComponentGetValue2(ability_comp, "sprite_file")

local box_width = 250
local box_height = 168

_gui = _gui or GuiCreate()
--just to get dimension
local icon_width, icon_height = GuiGetImageDimensions(_gui, wand_icon_image, 1)
--TODO:check sprite file is .png or .xml

local box_width = box_width + icon_width / 2 + 16

local spells = {}
local children = EntityGetAllChildren(entity_id)
if children ~= nil then
    for _, spell in pairs(children) do
        local action_comp = EntityGetFirstComponentIncludingDisabled(spell, "ItemActionComponent")
        if action_comp ~= nil then
            local item_comp = EntityGetFirstComponentIncludingDisabled(spell, "ItemComponent")
            if item_comp ~= nil then
                if ComponentGetValue2(item_comp, "permanently_attached") == false then --TODO:well,lets just forget it
                    table.insert(spells, ComponentGetValue2(action_comp, "action_id"))
                end
            end
        end
    end
end

if #spells == 0 then
    box_height = 168 + 16
    capacity = 0
else
    box_width = math.max(box_width, 11 + 16 + 28 * math.min(capacity, 10))
    box_height = 168 + (math.floor((capacity - 1) / 10) + 1) * 28 + 28
end

local flaws = {
    "wrong_name",
    "shuffle",
    "delay",
    "mana",
    "capacity",
    "wand_icon"
}
local flaw = flaws[Random(1,#flaws)]
print("flaw is: "..flaw)
if flaw == "shuffle" then
    if wand_attri[1][3] == "Yes" then
        if Random(100) > 50 then
            wand_attri[1][3] = "No"
        else
            wand_attri[1][3] = "True"
        end
    else
        if Random(100) > 50 then
            wand_attri[1][3] = "Yes"
        else
            wand_attri[1][3] = "False"
        end
    end
elseif flaw == "delay" then
    wand_attri[3][3] = string.format("%.2f", ComponentObjectGetValue2(ability_comp, "gunaction_config", "fire_rate_wait"))
    wand_attri[4][3] = string.format("%.2f", ComponentObjectGetValue2(ability_comp, "gun_config", "reload_time"))
elseif flaw == "mana" then
    wand_attri[5][3] =wand_attri[5][3]..string.format("%.2f",Random())
    wand_attri[6][3] =wand_attri[6][3].. string.format("%.2f",Random())
elseif flaw == "capacity" then
    wand_attri[7][3] = tostring(capacity + Random(8, 15))
end
--TODO:add permanent cast infomation

local box_width_pixel = box_width / 2
local box_height_pixel = box_height / 2

local fake_panel = EntityLoad("mods/mimic_info_box/entities/panel_mimic.xml", target_x, target_y)
local background_comp, board_l, board_r, board_t, board_b
background_comp = EntityGetFirstComponentIncludingDisabled(fake_panel, "SpriteComponent", "item_bg")
board_l = EntityGetFirstComponentIncludingDisabled(fake_panel, "SpriteComponent", "text_board_l")
board_r = EntityGetFirstComponentIncludingDisabled(fake_panel, "SpriteComponent", "text_board_r")
board_t = EntityGetFirstComponentIncludingDisabled(fake_panel, "SpriteComponent", "text_board_t")
board_b = EntityGetFirstComponentIncludingDisabled(fake_panel, "SpriteComponent", "text_board_b")

ComponentSetValue2(board_l, "special_scale_x", 1 / 3)
ComponentSetValue2(board_r, "special_scale_x", 1 / 3)
ComponentSetValue2(board_t, "special_scale_y", 1 / 3)
ComponentSetValue2(board_b, "special_scale_y", 1 / 3)

--set board and background sacle
ComponentSetValue2(background_comp, "special_scale_x", box_width_pixel * 1 / 3)
ComponentSetValue2(background_comp, "special_scale_y", box_height_pixel * 1 / 3)
ComponentSetValue2(board_l, "special_scale_y", box_height_pixel * 1 / 3)
ComponentSetValue2(board_r, "special_scale_y", box_height_pixel * 1 / 3)
ComponentSetValue2(board_t, "special_scale_x", box_width_pixel * 1 / 3)
ComponentSetValue2(board_b, "special_scale_x", box_width_pixel * 1 / 3)

--set board offset
ComponentSetValue2(board_l, "offset_x", box_width_pixel + 2)
ComponentSetValue2(board_r, "offset_x", -box_width_pixel)
ComponentSetValue2(board_t, "offset_y", box_height_pixel + 2)
ComponentSetValue2(board_b, "offset_y", -box_height_pixel)

local left_title_start = (box_width / 2 - 12) / 2
local left_text_start = (box_width / 2 - 36) / 2
local right_text_start = (box_width / 2 - 152) / 2
local wand_name = "WAND"
if flaw == "wrong_name" then
    wand_name = "MIMIC"
end
local sprite_comp =
    EntityAddComponent2(
    fake_panel,
    "SpriteComponent",
    {
        is_text_sprite = true,
        alpha = 0.85,
        z_index = -3,
        update_transform = true,
        update_transform_rotation = false,
        image_file = "data/fonts/font_pixel_white.xml",
        text = wand_name,
        --additive=true,
        emissive = true,
        has_special_scale = true,
        special_scale_x = 2 / 3,
        special_scale_y = 2 / 3,
        offset_x = left_title_start,
        offset_y = (box_height / 2 - 16) / 2
    }
)
ComponentAddTag(sprite_comp, "enabled_in_world")

local line_height = (box_height / 2 - 42) / 2
for i, attri in pairs(wand_attri) do
    ComponentAddTag(
        EntityAddComponent2(
            fake_panel,
            "SpriteComponent",
            {
                z_index = -3,
                update_transform = true,
                update_transform_rotation = false,
                image_file = attri[1],
                --additive=true,
                emissive = true,
                has_special_scale = true,
                special_scale_x = 2 / 3,
                special_scale_y = 2 / 3,
                offset_x = left_title_start,
                offset_y = line_height
            }
        ),
        "enabled_in_world"
    )
    ComponentAddTag(
        EntityAddComponent2(
            fake_panel,
            "SpriteComponent",
            {
                is_text_sprite = true,
                alpha = 0.85,
                z_index = -3,
                update_transform = true,
                update_transform_rotation = false,
                image_file = "data/fonts/font_pixel_white.xml",
                text = GameTextGetTranslatedOrNot(attri[2]),
                emissive = true,
                has_special_scale = true,
                special_scale_x = 2 / 3,
                special_scale_y = 2 / 3,
                offset_x = left_text_start,
                offset_y = line_height
            }
        ),
        "enabled_in_world"
    )
    ComponentAddTag(
        EntityAddComponent2(
            fake_panel,
            "SpriteComponent",
            {
                is_text_sprite = true,
                alpha = 1,
                z_index = -3,
                update_transform = true,
                update_transform_rotation = false,
                image_file = "data/fonts/font_pixel_white.xml",
                text = attri[3],
                emissive = true,
                has_special_scale = true,
                special_scale_x = 2 / 3,
                special_scale_y = 2 / 3,
                offset_x = right_text_start,
                offset_y = line_height
            }
        ),
        "enabled_in_world"
    )

    line_height = line_height - 8
end

--add spell slot and spell
if capacity > 0 then
    for i = 0, capacity - 1, 1 do
        local index_y = math.floor(i / 10)
        local index_x = i - 10 * index_y
        local offset_x = (box_width / 2 - 12 - index_x * 28) * 20 / 28
        local offset_y = (box_height / 2 - 170 - 14 - index_y * 28) * 20 / 28
        ComponentAddTag(
            EntityAddComponent2(
                fake_panel,
                "SpriteComponent",
                {
                    alpha = 1,
                    z_index = -2,
                    update_transform = true,
                    update_transform_rotation = false,
                    image_file = "data/ui_gfx/inventory/inventory_box.png",
                    emissive = true,
                    has_special_scale = true,
                    special_scale_x = 28 / 60,
                    special_scale_y = 28 / 60,
                    offset_x = offset_x,
                    offset_y = offset_y
                }
            ),
            "enabled_in_world"
        )
        if spells[i + 1] ~= nil then
            local type, sprite = get_acion_info(spells[i + 1])
            local bg_sprite
            if type == ACTION_TYPE_PROJECTILE then
                bg_sprite = "data/ui_gfx/inventory/item_bg_projectile.png"
            elseif type == ACTION_TYPE_MODIFIER then
                bg_sprite = "data/ui_gfx/inventory/item_bg_modifier.png"
            elseif type == ACTION_TYPE_DRAW_MANY then
                bg_sprite = "data/ui_gfx/inventory/item_bg_draw_many.png"
            elseif type == ACTION_TYPE_STATIC_PROJECTILE then
                bg_sprite = "data/ui_gfx/inventory/item_bg_static_projectile.png"
            elseif type == ACTION_TYPE_MATERIAL then
                bg_sprite = "data/ui_gfx/inventory/item_bg_material.png"
            elseif type == CTION_TYPE_PASSIVE then
                bg_sprite = "data/ui_gfx/inventory/item_bg_passive.png"
            elseif type == ACTION_TYPE_OTHER then
                bg_sprite = "data/ui_gfx/inventory/item_bg_other.png"
            end
            ComponentAddTag(
                EntityAddComponent2(
                    fake_panel,
                    "SpriteComponent",
                    {
                        alpha = 1,
                        z_index = -2,
                        update_transform = true,
                        update_transform_rotation = false,
                        image_file = bg_sprite,
                        emissive = true,
                        has_special_scale = true,
                        special_scale_x = 28 / 60,
                        special_scale_y = 28 / 60,
                        offset_x = offset_x + 60 / 28,
                        offset_y = offset_y + 60 / 28
                    }
                ),
                "enabled_in_world"
            )
            ComponentAddTag(
                EntityAddComponent2(
                    fake_panel,
                    "SpriteComponent",
                    {
                        alpha = 1,
                        z_index = -1,
                        update_transform = true,
                        update_transform_rotation = false,
                        image_file = sprite,
                        emissive = true,
                        has_special_scale = true,
                        special_scale_x = 28 / 60,
                        special_scale_y = 28 / 60,
                        offset_x = offset_x - 20 / 28,
                        offset_y = offset_y - 20 / 28
                    }
                ),
                "enabled_in_world"
            )
        end
    end
end

EntityAddComponent2(
    fake_panel,
    "VariableStorageComponent",
    {
        name = "panel_dimension",
        value_int = box_height,
        value_float = box_width
    }
)

local wand_icon = EntityLoad("mods/mimic_info_box/entities/fake_wand_icon.xml", target_x, target_y)
local icon_comp = EntityGetFirstComponentIncludingDisabled(wand_icon, "SpriteComponent")
ComponentSetValue2(icon_comp, "image_file", wand_icon_image)
if flaw == "wand_icon" then
    ComponentSetValue2(icon_comp, "offset_x", icon_width / 2 + 5)
    ComponentSetValue2(icon_comp, "offset_y", (icon_height / 2 + 53 / 2))
    EntitySetTransform(wand_icon, target_x, target_y, math.pi / 2)
else
    ComponentSetValue2(icon_comp, "offset_x", icon_width / 2 - 5)
    ComponentSetValue2(icon_comp, "offset_y", icon_height / 2 - 53 / 2)
    EntitySetTransform(wand_icon, target_x, target_y, -math.pi / 2)
end

EntityAddChild(fake_panel, wand_icon)
EntitySetComponentsWithTagEnabled(wand_icon, "enabled_in_world", true)

--other things

local hit_box_comp = EntityGetFirstComponentIncludingDisabled(fake_panel, "HitboxComponent")
ComponentSetValue2(hit_box_comp, "aabb_min_x", -(box_width / 2) / 3)
ComponentSetValue2(hit_box_comp, "aabb_max_x", (box_width / 2) / 3)
ComponentSetValue2(hit_box_comp, "aabb_min_y", -(box_height / 2) / 3)
ComponentSetValue2(hit_box_comp, "aabb_max_y", (box_height / 2) / 3)

local character_comp = EntityGetFirstComponentIncludingDisabled(fake_panel, "CharacterDataComponent")
ComponentSetValue2(character_comp, "collision_aabb_min_x", -(box_width / 2) / 3)
ComponentSetValue2(character_comp, "collision_aabb_max_x", (box_width / 2) / 3)
ComponentSetValue2(character_comp, "collision_aabb_min_y", -(box_height / 2) / 3)
ComponentSetValue2(character_comp, "collision_aabb_max_y", (box_height / 2) / 3)
EntityRemoveComponent(entity_id, GetUpdatedComponentID())

EntityAddChild(entity_id, fake_panel)
