dofile_once("data/scripts/gun/gun_enums.lua")
dofile_once("data/scripts/gun/gun_actions.lua")
function get_acion_info(action_id)
    for _, data in pairs(actions) do
        if data.id == action_id then
            return data.type, data.sprite
        end
    end
end

function enable_wand(entity_id)
    local item_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "ItemComponent")
    ComponentSetValue2(item_comp, "is_pickable", true)
    local interact_comps = EntityGetComponentIncludingDisabled(entity_id, "InteractableComponent")
    for _, comp in pairs(interact_comps) do
        if ComponentGetValue2(comp, "name") == "invoke_panel_mimic" then
            EntityRemoveComponent(entity_id, comp)
            break
        end
    end
    EntityAddTag(entity_id, "wand")
end

function has_spell_in_it(item_id)
    if item_id <= 0 then
        return false
    end
    local childern = EntityGetAllChildren(item_id)
    if childern == nil then
        return false
    end
    for _, child_id in pairs(childern) do
        local action_comp = EntityGetFirstComponentIncludingDisabled(child_id, "ItemActionComponent")
        if action_comp ~= nil then
            local item_comp = EntityGetFirstComponentIncludingDisabled(child_id, "ItemComponent")
            if item_comp ~= nil then
                if ComponentGetValue2(item_comp, "permanently_attached") == false then
                    local aciton_id = ComponentGetValue2(action_comp, "action_id")
                    if aciton_id ~= "" then
                        return true, child_id,aciton_id
                    end
                end
            end
        end
    end
    return false
end
function mimic_add_spell(mimic_id, spell_id, index)
    local var_comps = EntityGetComponentIncludingDisabled(mimic_id, "VariableStorageComponent")
    local box_height, box_width
    for _, comp in pairs(var_comps) do
        if ComponentGetValue2(comp, "name") == "panel_dimension" then
            box_height = ComponentGetValue2(comp, "value_int")
            box_width = ComponentGetValue2(comp, "value_float")
        end
    end

    local index_y = math.floor( index / 10)
    local index_x =  index - 10 * index_y
    local offset_x = (box_width / 2 - 12 - index_x * 28) * 20 / 28
    local offset_y = (box_height / 2 - 170 - 14 - index_y * 28) * 20 / 28

    local type, sprite = get_acion_info(spell_id)
    local bg_sprite
    if type == ACTION_TYPE_PROJECTILE then
        bg_sprite = "data/ui_gfx/inventory/item_bg_projectile.png"
    elseif type == ACTION_TYPE_MODIFIER then
        bg_sprite = "data/ui_gfx/inventory/item_bg_modifier.png"
    elseif type == ACTION_TYPE_DRAW_MANY then
        bg_sprite = "data/ui_gfx/inventory/item_bg_draw_many.png"
    elseif type == ACTION_TYPE_STATIC_PROJECTILE then
        bg_sprite = "data/ui_gfx/inventory/item_bg_static_projectile.png"
    elseif type == ACTION_TYPE_MATERIAL then
        bg_sprite = "data/ui_gfx/inventory/item_bg_material.png"
    elseif type == CTION_TYPE_PASSIVE then
        bg_sprite = "data/ui_gfx/inventory/item_bg_passive.png"
    elseif type == ACTION_TYPE_OTHER then
        bg_sprite = "data/ui_gfx/inventory/item_bg_other.png"
    end
    ComponentAddTag(
        EntityAddComponent2(
            mimic_id,
            "SpriteComponent",
            {
                alpha = 1,
                z_index = -2,
                update_transform = true,
                update_transform_rotation = false,
                image_file = bg_sprite,
                emissive = true,
                has_special_scale = true,
                special_scale_x = 28 / 60,
                special_scale_y = 28 / 60,
                offset_x = offset_x + 60 / 28,
                offset_y = offset_y + 60 / 28
            }
        ),
        "enabled_in_world"
    )
    ComponentAddTag(
        EntityAddComponent2(
            mimic_id,
            "SpriteComponent",
            {
                alpha = 1,
                z_index = -1,
                update_transform = true,
                update_transform_rotation = false,
                image_file = sprite,
                emissive = true,
                has_special_scale = true,
                special_scale_x = 28 / 60,
                special_scale_y = 28 / 60,
                offset_x = offset_x - 20 / 28,
                offset_y = offset_y - 20 / 28
            }
        ),
        "enabled_in_world"
    )
end
function eat_spell_on_hand(entity_id,panel_mimic)
    local player_id = EntityGetWithTag("player_unit")[1]
    local spell_eaten,action_id

    local ability_comp = EntityGetFirstComponent(entity_id, "AbilityComponent")
    if ability_comp == nil then
        return false
    end
    local capacity = ComponentObjectGetValue2(ability_comp, "gun_config", "deck_capacity")

    local spells = {}
    local children_spell = EntityGetAllChildren(entity_id)
    if children_spell ~= nil then
        for _, spell in pairs(children_spell) do
            local action_comp = EntityGetFirstComponentIncludingDisabled(spell, "ItemActionComponent")
            if action_comp ~= nil then
                local item_comp = EntityGetFirstComponentIncludingDisabled(spell, "ItemComponent")
                if item_comp ~= nil then
                    if ComponentGetValue2(item_comp, "permanently_attached") == false then --TODO:well,lets just forget it
                        local inventory_x, inventory_y = ComponentGetValue2(item_comp, "inventory_slot")
                        table.insert(spells, inventory_x, ComponentGetValue2(action_comp, "action_id"))
                    end
                end
            end
        end
    end

    if #spells == capacity then
        return false
    end

    if player_id ~= nil then
        --check held wand
        local inventory2_comp = EntityGetFirstComponentIncludingDisabled(player_id, "Inventory2Component")
        local held_item = ComponentGetValue2(inventory2_comp, "mActiveItem")
        local has_spell
        has_spell, spell_eaten,action_id = has_spell_in_it(held_item)
        if has_spell then
            EntityRemoveFromParent(spell_eaten)
        end
        --check other wand
        if has_spell == nil then
            local inventorys = EntityGetAllChildren(player_id)
            for _, inventory in pairs(inventorys) do
                if EntityGetName(inventory) == "inventory_quick" then
                    local items = EntityGetAllChildren(inventory)
                    for _, item in pairs(items) do
                        has_spell, spell_eaten,action_id = has_spell_in_it(item)
                        if has_spell then
                            EntityRemoveFromParent(spell_eaten)
                        end
                    end
                    break
                end
            end
        end
    end

    if spell_eaten == nil then
        return false
    end

    -- inster spell
    local spell_pos = 0
    for i = 1, capacity, 1 do
        if spells[i] == nil then
            EntityAddChild(entity_id, spell_eaten)
            local item_comp = EntityGetFirstComponentIncludingDisabled(spell_eaten, "ItemComponent")
            ComponentSetValue2(item_comp, "inventory_slot", 1, 0)
            local ability_comp = EntityGetFirstComponentIncludingDisabled(spell_eaten, "ItemComponent")
            spell_pos = i
            break
        end
    end

    --add sprite
    mimic_add_spell(panel_mimic, action_id, spell_pos)
    return true
end

function interacting(entity_who_interacted, entity_interacted, interactable_name)
    if interactable_name ~= "invoke_panel_mimic" then
        return
    end

    local panel_mimic
    local children = EntityGetAllChildren(entity_interacted)
    if children ~= nil then
        for _, child_entity in pairs(children) do
            local child_entity_name = EntityGetName(child_entity)

            if EntityGetName(child_entity) == "panel_mimic" then
                panel_mimic = child_entity
                break
            end
        end
    else
        return
    end

    if panel_mimic ~= nil then
        if eat_spell_on_hand(entity_interacted,panel_mimic) then
            GamePrintImportant("Mimic ate your spell!","kill it to get back!")
        else
            GamePrintImportant("Mimic tried to eat your spell... but failed.","Maybe it's too full")
        end

        local interacting_comp = EntityGetComponentIncludingDisabled(entity_interacted,"InteractableComponent")
        for _, comp in pairs(interacting_comp) do
            if ComponentGetValue2(comp,"name") == "invoke_panel_mimic" then
                ComponentSetValue2(comp,"ui_text","Press [E] to feed this mimic.")--TODO:add to localization file
            end
        end
    else
        enable_wand(entity_interacted)
        return
    end

end
